bbva<-ts(read.table("/Users/Kevin_Amate/Desktop/Series Temporales/BBVA.txt"))
bbva
plot.ts(bbva,col=4)

par(mfrow=c(1,1))
ret <- diff(log(bbva))
ret
plot.ts(ret,col=4)

par(mfrow=c(2,2))
acf(ret, main='ACF de los rendimientos')
pacf(ret, main='PACF de los rendimientos')
acf(ret^2, main='ACF del cuadrado de los rendimientos')
pacf(ret^2, main='PACF del cuadrado de los rendimientos')
par(mfrow=c(1,1))

m=mean(ret)
s=sd(ret)
par(mfrow=c(1,2))
hist(ret,main="Histograma de los rendimientos",nclass=100,freq=F)
curve(dnorm(x,mean=m,sd=s), from = -0.3, to = 0.2, add=T, col="red")

plot(density(ret), main = "Distribución empírica de los rendimientos")
curve(dnorm(x,mean=m,sd=s), from = -0.3, to = 0.2, add=T, col="red")#diagrama empirico comparado con normal
par(mfrow=c(1,1))

install.packages("moments")#kurtosis
library(moments)
kurtosis(ret)

par(mfrow=c(1,3))
plot(density(ret), main = "Zoom en las colas", xlim=c(-0.15,-0.05), ylim=c(0,20))#tail zoom
curve(dnorm(x,mean=m,sd=s), from = -0.3, to = 0.2, add=T, col="red")
plot(density(ret), main = "Zoom en las colas", xlim=c(0.05,0.1), ylim=c(0,20))#tail zoom
curve(dnorm(x,mean=m,sd=s), from = -0.3, to = 0.2, add=T, col="red")
qqnorm(ret)
qqline(ret)


ts <- ret-m
Box.test(ts^2) #no muestra efectos ARCH


install.packages("fGarch")
library("fGarch")


arch1 <- garchFit(formula =~garch(1,0),data = ret,cond.dist = "norm")
summary(arch1)
arch2 <- garchFit(formula =~garch(2,0),data = ret,cond.dist = "norm")
summary(arch2)
arch3 <- garchFit(formula =~garch(3,0),data = ret,cond.dist = "norm")
summary(arch3)
garch1.1 <- garchFit(formula =~garch(1,1),data = ret,cond.dist = "norm")
summary(garch1.1)
garch2.1 <- garchFit(formula =~garch(2,1),data = ret,cond.dist = "norm")
summary(garch2.1)
garch1.2 <- garchFit(formula =~garch(1,2),data = ret,cond.dist = "norm")
summary(garch1.2)
garch2.2 <- garchFit(formula =~garch(2,2),data = ret,cond.dist = "norm")
summary(garch2.2)
#GARCH(1,1)

par(mfrow=c(1,1))
predict(garch1.1,50,plot=T)
